unit UDemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AdvChartView, AdvChartViewGDIP, AdvChart, AdvChartGDIP;

type
  TForm10 = class(TForm)
    AdvGDIPChartView1: TAdvGDIPChartView;
    procedure FormCreate(Sender: TObject);
    procedure AdvGDIPChartView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AdvGDIPChartView1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AdvGDIPChartView1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AdvGDIPChartView1DrawChart(Sender: TObject; ARect: TRect;
      ACanvas: TCanvas);
  private
    { Private declarations }
    procedure ProcessSelection;
  public
    { Public declarations }
  end;

var
  Form10: TForm10;
  startp, endp: Integer;
  spX, fspx: integer;
  spEndX: integer;
  beginselection: Boolean;

implementation

{$R *.dfm}


procedure TForm10.AdvGDIPChartView1DrawChart(Sender: TObject; ARect: TRect;
  ACanvas: TCanvas);
var
  g: TGPGraphics;
  p: TGPPen;
  b: TGPSolidBrush;
begin
  if beginselection then
  begin
    g := TGPGraphics.Create(ACanvas.Handle);
    p := TGPPen.Create(MakeColor(255, clRed));
    b := TGPSolidBrush.Create(MakeColor(100, clRed));
    g.DrawLine(p, spx, ARect.Top, spx, ARect.Bottom);
    g.DrawLine(p, spendx, ARect.Top, spendx, ARect.Bottom);
    g.FillRectangle(b, spx, ARect.Top, spendx - spx, ARect.Bottom);
    b.Free;
    p.Free;
    g.Free;
  end;
end;

procedure TForm10.AdvGDIPChartView1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  startp := AdvGDIPChartView1.Panes[0].Series[0].GetXYPoint(X, Y);
  spX := X;
  fspx := x;
  spEndX := X;
  beginselection := True;
  AdvGDIPChartView1.Invalidate;
end;

procedure TForm10.AdvGDIPChartView1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if beginselection then
  begin
    if X < fspx then
    begin
      spx := X;
      spendx := fspx;
    end
    else
    begin
      spx := fspx;
      spendx := x;
    end;
    AdvGDIPChartView1.Invalidate;
  end;
end;

procedure TForm10.AdvGDIPChartView1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if beginselection then
  begin
    endp := AdvGDIPChartView1.Panes[0].Series[0].GetXYPoint(X, Y);
    ProcessSelection;
  end;
end;

procedure TForm10.FormCreate(Sender: TObject);
var
  i: integer;
  d: TDateTime;
begin
  with AdvGDIPChartView1.Panes[0] do
  begin
    XAxis.UnitType := utDay;
    XAxis.Size := 130;
    Title.Text := 'May 2011';
    Title.Size := 50;
    Title.Font.Size := 16;
    Range.StartDate := EncodeDate(2011, 05, 1);
    with Series[0] do
    begin
      AutoRange := arEnabled;
      ChartType := ctXYLine;
      XAxis.MajorUnitTimeFormat := 'dd/mm/yyyy';
      XAxis.TextBottom.Angle := 50;
      XAxis.MajorUnitSpacing := 20;
      XAxis.XYValuesOffset := 60;
      XAxis.AutoUnits := false;
      for I := 0 to 30 do
      begin
        d := EncodeDate(2011, 05, 1) + I;
        AddSinglePoint(Random(100), TDateTime(d));
      end;
    end;
    Range.RangeTo := 30;
  end;

end;

procedure TForm10.ProcessSelection;
var
  ptStart, ptEnd: TChartPoint;
begin
  if (startp <> -1) and (endp <> -1) then
  begin
    ptStart := AdvGDIPChartView1.Panes[0].Series[0].Points[startp];
    ptEnd := AdvGDIPChartView1.Panes[0].Series[0].Points[endp];
    ShowMessage('Point Value 1: ' + floattostr(ptStart.SingleValue) + 'Point Value 2: ' + floattostr(ptEnd.SingleValue));
    beginselection := false;
    AdvGDIPChartView1.Invalidate;
  end;
end;

end.
